## ros-noetic-witmotion-ros 1.3.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.8)
project(witmotion_ros)

# VERSIONING
if(NOT EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/witmotion-uart-qt/version")
    message(FATAL_ERROR "witmotion-uart-qt directory does not contain submodule data. Please update submodules to compile the underlying library in-place for ROS integration")
endif(NOT EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/witmotion-uart-qt/version")
execute_process(COMMAND git rev-parse --short HEAD
    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
    OUTPUT_VARIABLE COMMIT_ID
    OUTPUT_STRIP_TRAILING_WHITESPACE
)
file(STRINGS "witmotion-uart-qt/version" PROJECT_VERSION)
if(CMAKE_BUILD_TYPE STREQUAL "Release")
    set(PROJECT_VERSION "${PROJECT_VERSION}")
else(CMAKE_BUILD_TYPE STREQUAL "Release")
    set(PROJECT_VERSION "${PROJECT_VERSION}~dev_${COMMIT_ID}")
endif(CMAKE_BUILD_TYPE STREQUAL "Release")
message(STATUS "Building version ${PROJECT_VERSION}")
string(REGEX MATCH "[0-9]*\.[0-9]*\.[0-9]*" modified_version ${PROJECT_VERSION})
file(READ ${CMAKE_CURRENT_SOURCE_DIR}/package.xml package_data)
string(REGEX REPLACE "\<version\>.*\<\/version\>" "\<version\>${modified_version}\<\/version\>" package_data "${package_data}")
file(WRITE  ${CMAKE_CURRENT_SOURCE_DIR}/package.xml "${package_data}")

set(CMAKE_BUILD_TYPE Release)

find_package(catkin REQUIRED COMPONENTS
    roslib
    roscpp
    tf2
    sensor_msgs
    geometry_msgs
    std_msgs
    std_srvs
    nav_msgs
    tf2_geometry_msgs
    rosgraph_msgs
)

catkin_package(CATKIN_DEPENDS
    message_runtime
    tf2
    sensor_msgs
    geometry_msgs
    std_msgs
    std_srvs
    nav_msgs
    tf2_geometry_msgs
    rosgraph_msgs
)

add_subdirectory(witmotion-uart-qt)
include_directories(${catkin_INCLUDE_DIRS} include witmotion-uart-qt/include)

find_package(Qt5 REQUIRED COMPONENTS Core SerialPort)
set(CMAKE_AUTOMOC ON)
qt5_wrap_cpp(MOC_SOURCES
    include/witmotion_ros.h
    )

add_library(witmotion_ros
    ${MOC_SOURCES}
    src/witmotion_ros.cpp
    )
target_link_libraries(witmotion_ros ${catkin_LIBRARIES} witmotion-uart Qt5::Core Qt5::SerialPort)

add_executable(witmotion_ros_node src/witmotion_ros_node.cpp)
target_link_libraries(witmotion_ros_node PRIVATE ${catkin_LIBRARIES} witmotion_ros)

=== witmotion-uart-qt/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1)
project(witmotion-uart-qt)

# VERSIONING
execute_process(COMMAND git rev-parse --short HEAD
    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
    OUTPUT_VARIABLE COMMIT_ID
    OUTPUT_STRIP_TRAILING_WHITESPACE
)
file(STRINGS "version" PROJECT_VERSION)
if(CMAKE_BUILD_TYPE STREQUAL "Release")
    set(PROJECT_VERSION "${PROJECT_VERSION}")
else(CMAKE_BUILD_TYPE STREQUAL "Release")
    set(PROJECT_VERSION "${PROJECT_VERSION}~dev_${COMMIT_ID}")
endif(CMAKE_BUILD_TYPE STREQUAL "Release")
message(STATUS "Building version ${PROJECT_VERSION}")
configure_file(config/version.h.in
    ${CMAKE_CURRENT_SOURCE_DIR}/include/witmotion/version.h
    )

set (CMAKE_CXX_STANDARD 14)
include(CheckIncludeFile)
check_include_file("inttypes.h" HAVE_INTTYPES_H)
if(NOT HAVE_INTTYPES_H)
    message(FATAL_ERROR "\'inttypes.h\' include file required!. Please check your toolchain!")
endif(NOT HAVE_INTTYPES_H)
include_directories(include
    ${CMAKE_CURRENT_BINARY_DIR}
    )
find_package(Qt5 REQUIRED COMPONENTS Core SerialPort)
set(CMAKE_AUTOMOC ON)

# OPTIONS
option(BUILD_EXAMPLES "Whether build or not the set of example applications" ON)
option(BUILD_DOCS "Whether build or not HTML documentation" ON)

# LIBRARY
qt5_wrap_cpp(MOC_SOURCES
    include/witmotion/types.h
    include/witmotion/serial.h
    )
set(LIBRARY_SHARED_HEADERS
    include/witmotion/types.h
    include/witmotion/util.h
    include/witmotion/serial.h
)
set(LIBRARY_SOURCES
    ${MOC_SOURCES}
    src/util.cpp
    src/serial.cpp
    )
add_library(witmotion-uart SHARED
    ${LIBRARY_SHARED_HEADERS}
    ${LIBRARY_SOURCES}
)
target_link_libraries(witmotion-uart Qt5::Core Qt5::SerialPort)

qt5_wrap_cpp(MOC_ENUMERATOR
    include/witmotion/message-enumerator.h
    )
add_executable(message-enumerator
    src/message-enumerator.cpp
    ${MOC_ENUMERATOR}
    )
target_link_libraries(message-enumerator
    Qt5::Core Qt5::SerialPort
    witmotion-uart
    )

# WT31N
qt5_wrap_cpp(MOC_WT31N
    include/witmotion/wt31n-uart.h
    )
add_library(witmotion-wt31n SHARED
    ${MOC_WT31N}
    src/wt31n-uart.cpp
    )
target_link_libraries(witmotion-wt31n witmotion-uart Qt5::Core)
add_executable(witmotionctl-wt31n
    ${MOC_WT31N}
    src/wt31n-control.cpp
    )
target_link_libraries(witmotionctl-wt31n witmotion-wt31n Qt5::Core)

# WT901
qt5_wrap_cpp(MOC_WT901
    include/witmotion/wt901-uart.h
    )
add_library(witmotion-wt901 SHARED
    ${MOC_WT901}
    src/wt901-uart.cpp
    )
target_link_libraries(witmotion-wt901 witmotion-uart Qt5::Core)
add_executable(witmotionctl-wt901
    ${MOC_WT901}
    src/wt901-control.cpp
    )
target_link_libraries(witmotionctl-wt901 witmotion-wt901 Qt5::Core)

# JY901
qt5_wrap_cpp(MOC_JY901
    include/witmotion/jy901-uart.h
    )
add_library(witmotion-jy901 SHARED
    ${MOC_JY01}
    src/jy901-uart.cpp
    )
target_link_libraries(witmotion-jy901 witmotion-wt901 Qt5::Core)
add_executable(witmotionctl-jy901
    ${MOC_JY901}
    src/jy901-control.cpp
    )
target_link_libraries(witmotionctl-jy901 witmotion-jy901 Qt5::Core)

# EXAMPLES
if(BUILD_EXAMPLES)
    add_executable(wt31n-calibration
        examples/wt31n/calibration-standalone.cpp
        )
    target_link_libraries(wt31n-calibration Qt5::Core Qt5::SerialPort)

    add_executable(wt31n-standalone-decoder
        examples/wt31n/witmotion-wt31n-uart-test.cpp
        )
    target_link_libraries(wt31n-standalone-decoder Qt5::Core Qt5::SerialPort)
endif(BUILD_EXAMPLES)

# DOCUMENTATION
if(BUILD_DOCS)
    include(cmake/doxygen-generator.cmake)
    if(${PROJECT_NAME}_DOCS_EXISTS)
        add_custom_target(docs ALL DEPENDS doc-${PROJECT_NAME})
    endif(${PROJECT_NAME}_DOCS_EXISTS)
endif(BUILD_DOCS)

# INSTALLATION

=== debian/changelog ===
ros-noetic-witmotion-ros (1.3.1-1focal) focal; urgency=high

  * Fixed GPS decoder function in the underlying library (added x10 multiplier in Degrees section)
  * Version bump to 1.3.1
  * Community-driven test of the library on WTGAHRS1 combined enclosed IMU/GPS sensor module <https://www.wit-motion.com/inertial-navigation/witmotion-wtgahrs1-10-axis-gps.html> by Quing Joe Wong joewong00
  * Contributors: Andrey Vukolov, Quing Joe Wong

 -- Andrey Vukolov <andrey.vukolov@elettra.eu>  Mon, 07 Aug 2023 22:00:00 -0000

ros-noetic-witmotion-ros (1.3.0-1focal) focal; urgency=high

  * Added support for serial port timeout behaviour (timeout_ms)
  * Updated README.md
  * Merged pull request #27 <https://github.com/ElettraSciComp/witmotion_IMU_ros/pull/27> from gsokoll
  * Version bump to 1.3.0
  * Matched versions for ROS node and underlying library after merging pull request #7 <https://github.com/ElettraSciComp/witmotion_IMU_QT/pull/7>

 -- Andrey Vukolov <andrey.vukolov@elettra.eu>  Tue, 13 Jun 2023 22:00:00 -0000

ros-noetic-witmotion-ros (1.2.28-1focal) focal; urgency=high

  * Updated online documentation
  * Updated CMake build scenario to suppress useless Doxygen warning
  * Version bump to 1.2.28
  * Matched versions for ROS node and underlying library

 -- Andrey Vukolov <andrey.vukolov@elettra.eu>  Mon, 20 Mar 2023 23:00:00 -0000

ros-noetic-witmotion-ros (1.2.27-1focal) focal; urgency=high

  * Merged pull request #12 <https://github.com/ElettraSciComp/witmotion_IMU_ros/issues/12> from fllay/main
    Migration to ROS2 made by @fllay approved. The information about the existence of the ROS2 branch will be added to README.md
  * Added ROS2 branch information to README
  * ros2 code
    Contributors: Andrei Vukolov, Andrey Vukolov, fllay
  * Update .gitmodules
    Updated URLs to proper HTTPS
  * Rename the project to witmotion_ros - cancelled
  * fixed segmentation fault when Ctrl-C
  * fixed polling interval and threading
  * Fix link error
  * package.xml version bump

 -- Andrey Vukolov <andrey.vukolov@elettra.eu>  Sun, 26 Feb 2023 23:00:00 -0000

ros-noetic-witmotion-ros (0.11.18-1focal) focal; urgency=high

  * README fix
  * Added RTC pre-synchronization
    - Fixed RTC callback crash
    - Implemented ISO8601 date conversion for pre-synchronization
    - Added presync parameter
  * Version bump to 0.11.18
    - Fixed RTC unitialized STL pointer
    - Fixed Qt libraries linking
    - Fixed RTC publishing
    - TODO: Implementation of RTC precalibration
  * Contributors: Andrey Vukolov

 -- Andrey Vukolov <andrey.vukolov@elettra.eu>  Thu, 25 Aug 2022 22:00:00 -0000

ros-noetic-witmotion-ros (0.8.22-1focal) focal; urgency=high

  * Added dynamic versioning
    - Added automatic package.xml version generator
    - Added dependency on underlying library's 'version' file
    - Added automatic compatible ROS version string parser
    (GNU -> ROS)
  * Library version bumped to 0.8.22-alpha
  * Added convenient defaults for WT901 sensor on 200 Hz
  * Library version bump to 0.7.15-alpha
  * Version bump to 0.6.14-alpha
  * Defaults for WT31N
    - Added default configuration file for WT31N sensor
    - Added example launch file for WT31N sensor
    - Bumped library version
  * Added native quaternion support
    - Added 'use_native_orientation' parameter to IMU message
    publisher for forced waiting for native quaternion if
    the sensor provides it
    - Added native quaternion parser to IMU processing routine
    - Library version bump: the controller application for
    WT901 series sensors is now available
    - Tested on WT901 and JY901B sensors
  * IPFS Datasheet directory fix
  * Convenient defaults
    - Convenient defaults for spatial covariances (obtained from
    tests on spatially fixed WT901 sensor)
    - Convenient defaults for magnetometer linear calibration
    (conversion from 10x uTesla to Tesla)
    - Convenient defaults for magnetometer covariance
  * Qt namespace workaround
    - Library with fully implemented Qt namespace workaround
    - Closes #9 <https://github.com/ElettraSciComp/witmotion_IMU_ros/issues/9>
    - Prevalidation of WT901 controller application
  * Snapped to library version 0.3.1-alpha
  * Fixed IPFS hash
  * Fixed logical error in IMU publisher
  * Update README.md
    Closes #6 <https://github.com/ElettraSciComp/witmotion_IMU_ros/issues/6>
  * Submodule update
  * README update for RTC
  * Added RTC publisher support
    - Refers to #3 <https://github.com/ElettraSciComp/witmotion_IMU_ros/issues/3> opened by @rlabs-oss
    - Implements ROS timestamp publishing based on realtime clock data
    from Witmotion sensor device
  * Readme fix, closes #2 <https://github.com/ElettraSciComp/witmotion_IMU_ros/issues/2> after adding installation guile
  * Added installation guidance, minor fixes
  * Merge pull request #5 <https://github.com/ElettraSciComp/witmotion_IMU_ros/issues/5> from agtbaskara/fix-missing-std-srvs
    Merged closing #4 <https://github.com/ElettraSciComp/witmotion_IMU_ros/issues/4>
  * Add std_srvs dependency
  * README to ROS Wiki link
  * Merge pull request #1 <https://github.com/ElettraSciComp/witmotion_IMU_ros/issues/1> from zacharykratochvil/main
    Merge: fixed linking to tf_geometry_msgs package from @zacharykratochvil
  * Merge branch 'main' into main
  * Added untested GPS decoder code
    - Added GPS decoder code with covariance dependency
    - Added GPS accuracy message decoder
    - Added GPS ground speed decoder
  * fixed linking to tf_geometry_msgs package
  * Updated README for last topic addition
  * Added Orientation processing and publishing
  * Renaming
  * Rebase
  * LICENSE added
  * Initial documentation before migration
  * First alpha release
  * Contributors: Andrei Vukolov, Andrey Vukolov, agtbaskara, zacharykratochvil

 -- Andrey Vukolov <andrey.vukolov@elettra.eu>  Sun, 21 Aug 2022 22:00:00 -0000

=== debian/control ===
Source: ros-noetic-witmotion-ros
Section: misc
Priority: optional
Maintainer: Andrey Vukolov <andrey.vukolov@elettra.eu>
Build-Depends: debhelper (>= 9.0.0), libqt5serialport5-dev, ros-noetic-catkin, ros-noetic-geometry-msgs, ros-noetic-message-runtime, ros-noetic-nav-core, ros-noetic-nav-msgs, ros-noetic-roscpp, ros-noetic-rosgraph-msgs, ros-noetic-sensor-msgs, ros-noetic-std-msgs, ros-noetic-std-srvs, ros-noetic-tf2, ros-noetic-tf2-geometry-msgs
Homepage: https://wiki.ros.org/witmotion_ros
Standards-Version: 3.9.2

Package: ros-noetic-witmotion-ros
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libqt5serialport5-dev, ros-noetic-geometry-msgs, ros-noetic-message-runtime, ros-noetic-nav-core, ros-noetic-nav-msgs, ros-noetic-roscpp, ros-noetic-rosgraph-msgs, ros-noetic-sensor-msgs, ros-noetic-std-msgs, ros-noetic-std-srvs, ros-noetic-tf2, ros-noetic-tf2-geometry-msgs
Description: Standalone QT-based IMU/GPS decoder nodes for Witmotion UART-compatible sensor devices

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/noetic/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF -DCATKIN_ENABLE_TESTING=OFF
endif

DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

%:
	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/noetic" \
		-DCMAKE_PREFIX_PATH="/opt/ros/noetic" \
		$(BUILD_TESTING_ARG)

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-noetic-witmotion-ros//opt/ros/noetic/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_install
